//============================================================
// Header der Stringklasse
//============================================================

#ifndef _DYNSTR_H_
#define _DYNSTR_H_

class dynstr
{
   //---------------------------------------------------------
   // Member-Variablen, nach Mglichkeit immer PRIVATE !
   //---------------------------------------------------------
   private:
      char *ptr;

   //---------------------------------------------------------
   // (Methoden) Member-Funktionen 
   //---------------------------------------------------------
   public:

      //------------------------------------------------------
      // Constructoren und Destructor
      //------------------------------------------------------
       dynstr ();            // Constructor
       dynstr (dynstr& x);   // Constructor
      ~dynstr ();

      //------------------------------------------------------
      // Methoden
      //------------------------------------------------------
      char *get     (void) const       {return (ptr);};
      void  set     (char *toset);
      int   len     (char *tocount) const;
      void  concat  (char *toadd);
      void  lower   (void);
      void  upper   (void);
      char *ltrim   (void);
      char *rtrim   (void);
      char *alltrim (void);
      
      //------------------------------------------------------
      // Operatoren
      //------------------------------------------------------
      char *operator=  (dynstr & tocopy);
      char *operator=  (char *tocopy);
      int   operator== (dynstr & tocheck);
      int   operator== (char *tocheck);
};
#endif
