#include <excpt.h>
#include <except.h>
#include <iostream.h>
#include <stdlib.h>

//------------------------------------------------------------------------------
// Funktion mit Exceptionhandling
//------------------------------------------------------------------------------
double fnFakultaet (int Param)
{
   double Ergebnis = 1.0;

   //---------------------------------------------------------------------------
   // Exception auslsen
   //---------------------------------------------------------------------------
   if (Param > 50) throw "Parameter zu gro";
   if (Param < 0)  throw 1;

  	if (0 == Param) Param = 1;
   for (int i=Param; i>1; i--) Ergebnis *= i;

   return Ergebnis;
}

//------------------------------------------------------------------------------
// Testprogramm
//------------------------------------------------------------------------------
void main (void)
{
   char sEingabe [80];
   int fak = 0;

   cout << "Parameter : ";
   cin.getline (sEingabe, 80);
   fak = atoi (sEingabe);

   //---------------------------------------------------------------------------
   // Die folgenden Codezeilen berwachen (try-Block)
   //---------------------------------------------------------------------------
   try
   {
      cout << fnFakultaet (fak) << endl;
   }
   //---------------------------------------------------------------------------
   // Exceptionhandler, wird aufgerufen, wenn im try-Block eine Exception
   // ausgelst wird
   //---------------------------------------------------------------------------
   catch (char *pError)
   {
      cout << pError;
   }
   catch (int nError)
   {
      cout << "Schwerer Fehler: negative Fakultt";
      terminate();
   }

   cout << endl << "Programmende" << endl;
}

